diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/traffic-control/model/queue-disc.cc ns-3.40/src/traffic-control/model/queue-disc.cc
--- ns-3.39/src/traffic-control/model/queue-disc.cc	2023-07-05 14:23:48.093428400 -0700
+++ ns-3.40/src/traffic-control/model/queue-disc.cc	2023-09-27 13:30:37.886839600 -0700
@@ -178,9 +178,6 @@
 void
 QueueDisc::Stats::Print(std::ostream& os) const
 {
-    std::map<std::string, uint32_t>::const_iterator itp;
-    std::map<std::string, uint64_t>::const_iterator itb;
-
     os << std::endl
        << "Packets/Bytes received: " << nTotalReceivedPackets << " / " << nTotalReceivedBytes
        << std::endl
@@ -195,8 +192,8 @@
        << "Packets/Bytes dropped before enqueue: " << nTotalDroppedPacketsBeforeEnqueue << " / "
        << nTotalDroppedBytesBeforeEnqueue;
 
-    itp = nDroppedPacketsBeforeEnqueue.begin();
-    itb = nDroppedBytesBeforeEnqueue.begin();
+    auto itp = nDroppedPacketsBeforeEnqueue.begin();
+    auto itb = nDroppedBytesBeforeEnqueue.begin();
 
     while (itp != nDroppedPacketsBeforeEnqueue.end() && itb != nDroppedBytesBeforeEnqueue.end())
     {
@@ -403,8 +400,7 @@
     InitializeParams();
 
     // Check the configuration and initialize the parameters of the child queue discs
-    for (std::vector<Ptr<QueueDiscClass>>::iterator cl = m_classes.begin(); cl != m_classes.end();
-         cl++)
+    for (auto cl = m_classes.begin(); cl != m_classes.end(); cl++)
     {
         (*cl)->GetQueueDisc()->Initialize();
     }
@@ -673,9 +669,7 @@
     NS_LOG_FUNCTION(this << item);
 
     int32_t ret = PacketFilter::PF_NO_MATCH;
-    for (std::vector<Ptr<PacketFilter>>::iterator f = m_filters.begin();
-         f != m_filters.end() && ret == PacketFilter::PF_NO_MATCH;
-         f++)
+    for (auto f = m_filters.begin(); f != m_filters.end() && ret == PacketFilter::PF_NO_MATCH; f++)
     {
         ret = (*f)->Classify(item);
     }
@@ -733,8 +727,7 @@
     m_stats.nTotalDroppedBytesBeforeEnqueue += item->GetSize();
 
     // update the number of packets dropped for the given reason
-    std::map<std::string, uint32_t>::iterator itp =
-        m_stats.nDroppedPacketsBeforeEnqueue.find(reason);
+    auto itp = m_stats.nDroppedPacketsBeforeEnqueue.find(reason);
     if (itp != m_stats.nDroppedPacketsBeforeEnqueue.end())
     {
         itp->second++;
@@ -744,7 +737,7 @@
         m_stats.nDroppedPacketsBeforeEnqueue[reason] = 1;
     }
     // update the amount of bytes dropped for the given reason
-    std::map<std::string, uint64_t>::iterator itb = m_stats.nDroppedBytesBeforeEnqueue.find(reason);
+    auto itb = m_stats.nDroppedBytesBeforeEnqueue.find(reason);
     if (itb != m_stats.nDroppedBytesBeforeEnqueue.end())
     {
         itb->second += item->GetSize();
@@ -773,8 +766,7 @@
     m_stats.nTotalDroppedBytesAfterDequeue += item->GetSize();
 
     // update the number of packets dropped for the given reason
-    std::map<std::string, uint32_t>::iterator itp =
-        m_stats.nDroppedPacketsAfterDequeue.find(reason);
+    auto itp = m_stats.nDroppedPacketsAfterDequeue.find(reason);
     if (itp != m_stats.nDroppedPacketsAfterDequeue.end())
     {
         itp->second++;
@@ -784,7 +776,7 @@
         m_stats.nDroppedPacketsAfterDequeue[reason] = 1;
     }
     // update the amount of bytes dropped for the given reason
-    std::map<std::string, uint64_t>::iterator itb = m_stats.nDroppedBytesAfterDequeue.find(reason);
+    auto itb = m_stats.nDroppedBytesAfterDequeue.find(reason);
     if (itb != m_stats.nDroppedBytesAfterDequeue.end())
     {
         itb->second += item->GetSize();
@@ -829,7 +821,7 @@
     m_stats.nTotalMarkedBytes += item->GetSize();
 
     // update the number of packets marked for the given reason
-    std::map<std::string, uint32_t>::iterator itp = m_stats.nMarkedPackets.find(reason);
+    auto itp = m_stats.nMarkedPackets.find(reason);
     if (itp != m_stats.nMarkedPackets.end())
     {
         itp->second++;
@@ -839,7 +831,7 @@
         m_stats.nMarkedPackets[reason] = 1;
     }
     // update the amount of bytes marked for the given reason
-    std::map<std::string, uint64_t>::iterator itb = m_stats.nMarkedBytes.find(reason);
+    auto itb = m_stats.nMarkedBytes.find(reason);
     if (itb != m_stats.nMarkedBytes.end())
     {
         itb->second += item->GetSize();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/traffic-control/model/red-queue-disc.cc ns-3.40/src/traffic-control/model/red-queue-disc.cc
--- ns-3.39/src/traffic-control/model/red-queue-disc.cc	2023-07-05 14:23:48.093428400 -0700
+++ ns-3.40/src/traffic-control/model/red-queue-disc.cc	2023-09-27 13:30:37.886839600 -0700
@@ -763,7 +763,7 @@
 RedQueueDisc::ModifyP(double p, uint32_t size)
 {
     NS_LOG_FUNCTION(this << p << size);
-    double count1 = (double)m_count;
+    auto count1 = (double)m_count;
 
     if (GetMaxSize().GetUnit() == QueueSizeUnit::BYTES)
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/traffic-control/model/red-queue-disc.h ns-3.40/src/traffic-control/model/red-queue-disc.h
--- ns-3.39/src/traffic-control/model/red-queue-disc.h	2023-07-05 14:23:48.093428400 -0700
+++ ns-3.40/src/traffic-control/model/red-queue-disc.h	2023-09-27 13:30:37.886839600 -0700
@@ -60,10 +60,11 @@
 #ifndef RED_QUEUE_DISC_H
 #define RED_QUEUE_DISC_H
 
+#include "queue-disc.h"
+
 #include "ns3/boolean.h"
 #include "ns3/data-rate.h"
 #include "ns3/nstime.h"
-#include "ns3/queue-disc.h"
 #include "ns3/random-variable-stream.h"
 
 namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/traffic-control/model/tbf-queue-disc.h ns-3.40/src/traffic-control/model/tbf-queue-disc.h
--- ns-3.39/src/traffic-control/model/tbf-queue-disc.h	2023-07-05 14:23:48.093428400 -0700
+++ ns-3.40/src/traffic-control/model/tbf-queue-disc.h	2023-09-27 13:30:37.886839600 -0700
@@ -28,11 +28,12 @@
 #ifndef TBF_QUEUE_DISC_H
 #define TBF_QUEUE_DISC_H
 
+#include "queue-disc.h"
+
 #include "ns3/boolean.h"
 #include "ns3/data-rate.h"
 #include "ns3/event-id.h"
 #include "ns3/nstime.h"
-#include "ns3/queue-disc.h"
 #include "ns3/random-variable-stream.h"
 #include "ns3/trace-source-accessor.h"
 #include "ns3/traced-value.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/traffic-control/model/traffic-control-layer.cc ns-3.40/src/traffic-control/model/traffic-control-layer.cc
--- ns-3.39/src/traffic-control/model/traffic-control-layer.cc	2023-07-05 14:23:48.093428400 -0700
+++ ns-3.40/src/traffic-control/model/traffic-control-layer.cc	2023-09-27 13:30:37.886839600 -0700
@@ -18,11 +18,12 @@
 
 #include "traffic-control-layer.h"
 
+#include "queue-disc.h"
+
 #include "ns3/log.h"
 #include "ns3/net-device-queue-interface.h"
 #include "ns3/object-map.h"
 #include "ns3/packet.h"
-#include "ns3/queue-disc.h"
 #include "ns3/socket.h"
 
 #include <tuple>
@@ -142,7 +143,7 @@
         Ptr<NetDeviceQueueInterface> ndqi = dev->GetObject<NetDeviceQueueInterface>();
         NS_LOG_DEBUG("Pointer to NetDeviceQueueInterface: " << ndqi);
 
-        std::map<Ptr<NetDevice>, NetDeviceInfo>::iterator ndi = m_netDevices.find(dev);
+        auto ndi = m_netDevices.find(dev);
 
         if (ndi != m_netDevices.end())
         {
@@ -221,7 +222,7 @@
 {
     NS_LOG_FUNCTION(this << device << qDisc);
 
-    std::map<Ptr<NetDevice>, NetDeviceInfo>::iterator ndi = m_netDevices.find(device);
+    auto ndi = m_netDevices.find(device);
 
     if (ndi == m_netDevices.end())
     {
@@ -243,7 +244,7 @@
 {
     NS_LOG_FUNCTION(this << device);
 
-    std::map<Ptr<NetDevice>, NetDeviceInfo>::const_iterator ndi = m_netDevices.find(device);
+    auto ndi = m_netDevices.find(device);
 
     if (ndi == m_netDevices.end())
     {
@@ -264,7 +265,7 @@
 {
     NS_LOG_FUNCTION(this << device);
 
-    std::map<Ptr<NetDevice>, NetDeviceInfo>::iterator ndi = m_netDevices.find(device);
+    auto ndi = m_netDevices.find(device);
 
     NS_ASSERT_MSG(ndi != m_netDevices.end() && ndi->second.m_rootQueueDisc,
                   "No root queue disc installed on device " << device);
@@ -336,7 +337,7 @@
 
     bool found = false;
 
-    for (ProtocolHandlerList::iterator i = m_handlers.begin(); i != m_handlers.end(); i++)
+    for (auto i = m_handlers.begin(); i != m_handlers.end(); i++)
     {
         if (!i->device || (i->device == device))
         {
@@ -364,7 +365,7 @@
     NS_LOG_DEBUG("Send packet to device " << device << " protocol number " << item->GetProtocol());
 
     Ptr<NetDeviceQueueInterface> devQueueIface;
-    std::map<Ptr<NetDevice>, NetDeviceInfo>::iterator ndi = m_netDevices.find(device);
+    auto ndi = m_netDevices.find(device);
 
     if (ndi != m_netDevices.end())
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/uan/examples/uan-6lowpan-example.cc ns-3.40/src/uan/examples/uan-6lowpan-example.cc
--- ns-3.39/src/uan/examples/uan-6lowpan-example.cc	2023-07-05 14:23:48.097428300 -0700
+++ ns-3.40/src/uan/examples/uan-6lowpan-example.cc	2023-09-27 13:30:37.890839800 -0700
@@ -131,7 +131,7 @@
     UanHelper uanHelper;
     NetDeviceContainer netDeviceContainer = uanHelper.Install(m_nodes, channel);
     EnergySourceContainer energySourceContainer;
-    NodeContainer::Iterator node = m_nodes.Begin();
+    auto node = m_nodes.Begin();
     while (node != m_nodes.End())
     {
         energySourceContainer.Add((*node)->GetObject<EnergySourceContainer>()->Get(0));
@@ -185,7 +185,7 @@
 void
 UanExperiment::SetupApplications()
 {
-    NodeContainer::Iterator node = m_nodes.Begin();
+    auto node = m_nodes.Begin();
     while (node != m_nodes.End())
     {
         m_sockets[*node] =
@@ -206,7 +206,7 @@
 {
     Ptr<UniformRandomVariable> uniformRandomVariable = CreateObject<UniformRandomVariable>();
 
-    NodeContainer::Iterator node = m_nodes.Begin();
+    auto node = m_nodes.Begin();
     Ipv6Address dst =
         (*node)->GetObject<Ipv6L3Protocol>()->GetInterface(1)->GetAddress(1).GetAddress();
     node++;
@@ -247,9 +247,7 @@
 void
 UanExperiment::Teardown()
 {
-    std::map<Ptr<Node>, Ptr<Socket>>::iterator socket;
-
-    for (socket = m_sockets.begin(); socket != m_sockets.end(); socket++)
+    for (auto socket = m_sockets.begin(); socket != m_sockets.end(); socket++)
     {
         socket->second->Close();
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/uan/examples/uan-cw-example.cc ns-3.40/src/uan/examples/uan-cw-example.cc
--- ns-3.39/src/uan/examples/uan-cw-example.cc	2023-07-05 14:23:48.097428300 -0700
+++ ns-3.40/src/uan/examples/uan-cw-example.cc	2023-09-27 13:30:37.890839800 -0700
@@ -106,7 +106,7 @@
 Experiment::UpdatePositions(NodeContainer& nodes) const
 {
     NS_LOG_DEBUG(Now().As(Time::S) << " Updating positions");
-    NodeContainer::Iterator it = nodes.Begin();
+    auto it = nodes.Begin();
     Ptr<UniformRandomVariable> uv = CreateObject<UniformRandomVariable>();
     for (; it != nodes.End(); it++)
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/uan/examples/uan-ipv4-example.cc ns-3.40/src/uan/examples/uan-ipv4-example.cc
--- ns-3.39/src/uan/examples/uan-ipv4-example.cc	2023-07-05 14:23:48.097428300 -0700
+++ ns-3.40/src/uan/examples/uan-ipv4-example.cc	2023-09-27 13:30:37.890839800 -0700
@@ -129,7 +129,7 @@
     UanHelper uanHelper;
     NetDeviceContainer netDeviceContainer = uanHelper.Install(m_nodes, channel);
     EnergySourceContainer energySourceContainer;
-    NodeContainer::Iterator node = m_nodes.Begin();
+    auto node = m_nodes.Begin();
     while (node != m_nodes.End())
     {
         energySourceContainer.Add((*node)->GetObject<EnergySourceContainer>()->Get(0));
@@ -176,7 +176,7 @@
 void
 UanExperiment::SetupApplications()
 {
-    NodeContainer::Iterator node = m_nodes.Begin();
+    auto node = m_nodes.Begin();
     while (node != m_nodes.End())
     {
         m_sockets[*node] =
@@ -197,7 +197,7 @@
 {
     Ptr<UniformRandomVariable> uniformRandomVariable = CreateObject<UniformRandomVariable>();
 
-    NodeContainer::Iterator node = m_nodes.Begin();
+    auto node = m_nodes.Begin();
     Ipv4Address dst =
         (*node)->GetObject<Ipv4L3Protocol>()->GetInterface(1)->GetAddress(0).GetLocal();
     node++;
@@ -238,9 +238,7 @@
 void
 UanExperiment::Teardown()
 {
-    std::map<Ptr<Node>, Ptr<Socket>>::iterator socket;
-
-    for (socket = m_sockets.begin(); socket != m_sockets.end(); socket++)
+    for (auto socket = m_sockets.begin(); socket != m_sockets.end(); socket++)
     {
         socket->second->Close();
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/uan/examples/uan-ipv6-example.cc ns-3.40/src/uan/examples/uan-ipv6-example.cc
--- ns-3.39/src/uan/examples/uan-ipv6-example.cc	2023-07-05 14:23:48.097428300 -0700
+++ ns-3.40/src/uan/examples/uan-ipv6-example.cc	2023-09-27 13:30:37.890839800 -0700
@@ -129,7 +129,7 @@
     UanHelper uanHelper;
     NetDeviceContainer netDeviceContainer = uanHelper.Install(m_nodes, channel);
     EnergySourceContainer energySourceContainer;
-    NodeContainer::Iterator node = m_nodes.Begin();
+    auto node = m_nodes.Begin();
     while (node != m_nodes.End())
     {
         energySourceContainer.Add((*node)->GetObject<EnergySourceContainer>()->Get(0));
@@ -180,7 +180,7 @@
 void
 UanExperiment::SetupApplications()
 {
-    NodeContainer::Iterator node = m_nodes.Begin();
+    auto node = m_nodes.Begin();
     while (node != m_nodes.End())
     {
         m_sockets[*node] =
@@ -201,7 +201,7 @@
 {
     Ptr<UniformRandomVariable> uniformRandomVariable = CreateObject<UniformRandomVariable>();
 
-    NodeContainer::Iterator node = m_nodes.Begin();
+    auto node = m_nodes.Begin();
     Ipv6Address dst =
         (*node)->GetObject<Ipv6L3Protocol>()->GetInterface(1)->GetAddress(1).GetAddress();
     node++;
@@ -242,9 +242,7 @@
 void
 UanExperiment::Teardown()
 {
-    std::map<Ptr<Node>, Ptr<Socket>>::iterator socket;
-
-    for (socket = m_sockets.begin(); socket != m_sockets.end(); socket++)
+    for (auto socket = m_sockets.begin(); socket != m_sockets.end(); socket++)
     {
         socket->second->Close();
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/uan/examples/uan-raw-example.cc ns-3.40/src/uan/examples/uan-raw-example.cc
--- ns-3.39/src/uan/examples/uan-raw-example.cc	2023-07-05 14:23:48.097428300 -0700
+++ ns-3.40/src/uan/examples/uan-raw-example.cc	2023-09-27 13:30:37.890839800 -0700
@@ -131,7 +131,7 @@
     UanHelper uanHelper;
     NetDeviceContainer netDeviceContainer = uanHelper.Install(m_nodes, channel);
     EnergySourceContainer energySourceContainer;
-    NodeContainer::Iterator node = m_nodes.Begin();
+    auto node = m_nodes.Begin();
     while (node != m_nodes.End())
     {
         energySourceContainer.Add((*node)->GetObject<EnergySourceContainer>()->Get(0));
@@ -165,7 +165,7 @@
 void
 UanExperiment::SetupApplications()
 {
-    NodeContainer::Iterator node = m_nodes.Begin();
+    auto node = m_nodes.Begin();
     PacketSocketHelper packetSocketHelper;
     while (node != m_nodes.End())
     {
@@ -187,7 +187,7 @@
 {
     Ptr<UniformRandomVariable> uniformRandomVariable = CreateObject<UniformRandomVariable>();
 
-    NodeContainer::Iterator node = m_nodes.Begin();
+    auto node = m_nodes.Begin();
     Mac8Address dst = Mac8Address::ConvertFrom((*node)->GetDevice(0)->GetAddress());
     node++;
     while (node != m_nodes.End())
@@ -230,9 +230,7 @@
 void
 UanExperiment::Teardown()
 {
-    std::map<Ptr<Node>, Ptr<Socket>>::iterator socket;
-
-    for (socket = m_sockets.begin(); socket != m_sockets.end(); socket++)
+    for (auto socket = m_sockets.begin(); socket != m_sockets.end(); socket++)
     {
         socket->second->Close();
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/uan/helper/uan-helper.cc ns-3.40/src/uan/helper/uan-helper.cc
--- ns-3.39/src/uan/helper/uan-helper.cc	2023-07-05 14:23:48.097428300 -0700
+++ ns-3.40/src/uan/helper/uan-helper.cc	2023-09-27 13:30:37.890839800 -0700
@@ -113,7 +113,7 @@
 void
 UanHelper::EnableAscii(std::ostream& os, NetDeviceContainer d)
 {
-    for (NetDeviceContainer::Iterator i = d.Begin(); i != d.End(); ++i)
+    for (auto i = d.Begin(); i != d.End(); ++i)
     {
         Ptr<NetDevice> dev = *i;
         EnableAscii(os, dev->GetNode()->GetId(), dev->GetIfIndex());
@@ -124,7 +124,7 @@
 UanHelper::EnableAscii(std::ostream& os, NodeContainer n)
 {
     NetDeviceContainer devs;
-    for (NodeContainer::Iterator i = n.Begin(); i != n.End(); ++i)
+    for (auto i = n.Begin(); i != n.End(); ++i)
     {
         Ptr<Node> node = *i;
         for (uint32_t j = 0; j < node->GetNDevices(); ++j)
@@ -156,7 +156,7 @@
 UanHelper::Install(NodeContainer c, Ptr<UanChannel> channel) const
 {
     NetDeviceContainer devices;
-    for (NodeContainer::Iterator i = c.Begin(); i != c.End(); i++)
+    for (auto i = c.Begin(); i != c.End(); i++)
     {
         Ptr<Node> node = *i;
 
@@ -193,7 +193,7 @@
 {
     int64_t currentStream = stream;
     Ptr<NetDevice> netDevice;
-    for (NetDeviceContainer::Iterator i = c.Begin(); i != c.End(); ++i)
+    for (auto i = c.Begin(); i != c.End(); ++i)
     {
         netDevice = (*i);
         Ptr<UanNetDevice> uan = DynamicCast<UanNetDevice>(netDevice);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/uan/model/acoustic-modem-energy-model.cc ns-3.40/src/uan/model/acoustic-modem-energy-model.cc
--- ns-3.39/src/uan/model/acoustic-modem-energy-model.cc	2023-07-05 14:23:48.097428300 -0700
+++ ns-3.40/src/uan/model/acoustic-modem-energy-model.cc	2023-09-27 13:30:37.890839800 -0700
@@ -19,13 +19,14 @@
 
 #include "acoustic-modem-energy-model.h"
 
+#include "uan-net-device.h"
+#include "uan-phy.h"
+
 #include "ns3/double.h"
 #include "ns3/energy-source.h"
 #include "ns3/log.h"
 #include "ns3/simulator.h"
 #include "ns3/trace-source-accessor.h"
-#include "ns3/uan-net-device.h"
-#include "ns3/uan-phy.h"
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/uan/model/uan-channel.cc ns-3.40/src/uan/model/uan-channel.cc
--- ns-3.39/src/uan/model/uan-channel.cc	2023-07-05 14:23:48.097428300 -0700
+++ ns-3.40/src/uan/model/uan-channel.cc	2023-09-27 13:30:37.890839800 -0700
@@ -84,7 +84,7 @@
         return;
     }
     m_cleared = true;
-    UanDeviceList::iterator it = m_devList.begin();
+    auto it = m_devList.begin();
     for (; it != m_devList.end(); it++)
     {
         if (it->first)
@@ -150,7 +150,7 @@
     Ptr<MobilityModel> senderMobility = nullptr;
 
     NS_LOG_DEBUG("Channel scheduling");
-    for (UanDeviceList::const_iterator i = m_devList.begin(); i != m_devList.end(); i++)
+    for (auto i = m_devList.begin(); i != m_devList.end(); i++)
     {
         if (src == i->second)
         {
@@ -160,7 +160,7 @@
     }
     NS_ASSERT(senderMobility);
     uint32_t j = 0;
-    UanDeviceList::const_iterator i = m_devList.begin();
+    auto i = m_devList.begin();
     for (; i != m_devList.end(); i++)
     {
         if (src != i->second)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/uan/model/uan-channel.h ns-3.40/src/uan/model/uan-channel.h
--- ns-3.39/src/uan/model/uan-channel.h	2023-07-05 14:23:48.097428300 -0700
+++ ns-3.40/src/uan/model/uan-channel.h	2023-09-27 13:30:37.890839800 -0700
@@ -20,11 +20,12 @@
 #ifndef UAN_CHANNEL_H
 #define UAN_CHANNEL_H
 
+#include "uan-noise-model.h"
+#include "uan-prop-model.h"
+
 #include "ns3/channel.h"
 #include "ns3/net-device.h"
 #include "ns3/packet.h"
-#include "ns3/uan-noise-model.h"
-#include "ns3/uan-prop-model.h"
 
 #include <list>
 #include <vector>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/uan/model/uan-header-rc.cc ns-3.40/src/uan/model/uan-header-rc.cc
--- ns-3.39/src/uan/model/uan-header-rc.cc	2023-07-05 14:23:48.097428300 -0700
+++ ns-3.40/src/uan/model/uan-header-rc.cc	2023-09-27 13:30:37.890839800 -0700
@@ -607,7 +607,7 @@
 {
     start.WriteU8(m_frameNo);
     start.WriteU8(GetNoNacks());
-    std::set<uint8_t>::iterator it = m_nackedFrames.begin();
+    auto it = m_nackedFrames.begin();
     for (; it != m_nackedFrames.end(); it++)
     {
         start.WriteU8(*it);
@@ -635,7 +635,7 @@
        << " Nacked: ";
     if (GetNoNacks() > 0)
     {
-        std::set<uint8_t>::iterator it = m_nackedFrames.begin();
+        auto it = m_nackedFrames.begin();
         os << (uint32_t)*it;
         it++;
         for (; it != m_nackedFrames.end(); it++)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/uan/model/uan-mac-cw.cc ns-3.40/src/uan/model/uan-mac-cw.cc
--- ns-3.39/src/uan/model/uan-mac-cw.cc	2023-07-05 14:23:48.097428300 -0700
+++ ns-3.40/src/uan/model/uan-mac-cw.cc	2023-09-27 13:30:37.890839800 -0700
@@ -19,12 +19,13 @@
 
 #include "uan-mac-cw.h"
 
+#include "uan-header-common.h"
+
 #include "ns3/attribute.h"
 #include "ns3/double.h"
 #include "ns3/log.h"
 #include "ns3/nstime.h"
 #include "ns3/trace-source-accessor.h"
-#include "ns3/uan-header-common.h"
 #include "ns3/uinteger.h"
 
 namespace ns3
@@ -150,7 +151,7 @@
             m_pktTx = packet;
             m_pktTxProt = GetTxModeIndex();
             m_state = CCABUSY;
-            uint32_t cw = (uint32_t)m_rv->GetValue(0, m_cw);
+            auto cw = (uint32_t)m_rv->GetValue(0, m_cw);
             m_savedDelayS = cw * m_slotTime;
             m_sendTime = Simulator::Now() + m_savedDelayS;
             NS_LOG_DEBUG("Time " << Now().As(Time::S) << ": Addr " << GetAddress()
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/uan/model/uan-mac-cw.h ns-3.40/src/uan/model/uan-mac-cw.h
--- ns-3.39/src/uan/model/uan-mac-cw.h	2023-07-05 14:23:48.097428300 -0700
+++ ns-3.40/src/uan/model/uan-mac-cw.h	2023-09-27 13:30:37.890839800 -0700
@@ -20,13 +20,14 @@
 #ifndef UAN_MAC_CW_H
 #define UAN_MAC_CW_H
 
+#include "uan-mac.h"
+#include "uan-phy.h"
+#include "uan-tx-mode.h"
+
 #include "ns3/mac8-address.h"
 #include "ns3/nstime.h"
 #include "ns3/random-variable-stream.h"
 #include "ns3/simulator.h"
-#include "ns3/uan-mac.h"
-#include "ns3/uan-phy.h"
-#include "ns3/uan-tx-mode.h"
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/uan/model/uan-mac-rc.cc ns-3.40/src/uan/model/uan-mac-rc.cc
--- ns-3.39/src/uan/model/uan-mac-rc.cc	2023-07-05 14:23:48.097428300 -0700
+++ ns-3.40/src/uan/model/uan-mac-rc.cc	2023-09-27 13:30:37.890839800 -0700
@@ -73,8 +73,7 @@
 
 Reservation::~Reservation()
 {
-    std::list<std::pair<Ptr<Packet>, Mac8Address>>::iterator it;
-    for (it = m_pktList.begin(); it != m_pktList.end(); it++)
+    for (auto it = m_pktList.begin(); it != m_pktList.end(); it++)
     {
         it->first = Ptr<Packet>((Packet*)nullptr);
     }
@@ -185,8 +184,7 @@
         m_phy->Clear();
         m_phy = nullptr;
     }
-    std::list<std::pair<Ptr<Packet>, Mac8Address>>::iterator it;
-    for (it = m_pktQueue.begin(); it != m_pktQueue.end(); it++)
+    for (auto it = m_pktQueue.begin(); it != m_pktQueue.end(); it++)
     {
         it->first = nullptr;
     }
@@ -424,7 +422,7 @@
 {
     NS_ASSERT(m_state == RTSSENT || m_state == GWPSENT);
 
-    std::list<Reservation>::iterator it = m_resList.begin();
+    auto it = m_resList.begin();
     for (; it != m_resList.end(); it++)
     {
         if (it->GetFrameNo() == ctsh.GetFrameNo())
@@ -455,8 +453,7 @@
     Time frameDelay = Seconds(0);
 
     const std::list<std::pair<Ptr<Packet>, Mac8Address>> l = it->GetPktList();
-    std::list<std::pair<Ptr<Packet>, Mac8Address>>::const_iterator pit;
-    pit = l.begin();
+    auto pit = l.begin();
 
     for (uint8_t i = 0; i < it->GetNoFrames(); i++, pit++)
     {
@@ -544,7 +541,7 @@
     UanHeaderRcAck ah;
     ack->RemoveHeader(ah);
 
-    std::list<Reservation>::iterator it = m_resList.begin();
+    auto it = m_resList.begin();
     for (; it != m_resList.end(); it++)
     {
         if (it->GetFrameNo() == ah.GetFrameNo())
@@ -565,11 +562,10 @@
     if (ah.GetNoNacks() > 0)
     {
         const std::list<std::pair<Ptr<Packet>, Mac8Address>> l = it->GetPktList();
-        std::list<std::pair<Ptr<Packet>, Mac8Address>>::const_iterator pit;
-        pit = l.begin();
+        auto pit = l.begin();
 
         const std::set<uint8_t>& nacks = ah.GetNackedFrames();
-        std::set<uint8_t>::iterator nit = nacks.begin();
+        auto nit = nacks.begin();
         uint8_t pnum = 0;
         for (; nit != nacks.end(); nit++)
         {
@@ -617,7 +613,7 @@
     m_resList.push_back(res);
     Ptr<UanPhyDual> phyDual = m_phy->GetObject<UanPhyDual>();
     bool phy1ok = IsPhy1Ok();
-    if (phy1ok && !phyDual->IsPhy2Tx() & !m_rtsBlocked)
+    if (phy1ok && !phyDual->IsPhy2Tx() && !m_rtsBlocked)
     {
         Ptr<Packet> pkt = Create<Packet>(0);
         pkt->AddHeader(CreateRtsHeader(res));
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/uan/model/uan-mac-rc-gw.cc ns-3.40/src/uan/model/uan-mac-rc-gw.cc
--- ns-3.39/src/uan/model/uan-mac-rc-gw.cc	2023-07-05 14:23:48.097428300 -0700
+++ ns-3.40/src/uan/model/uan-mac-rc-gw.cc	2023-09-27 13:30:37.890839800 -0700
@@ -84,7 +84,7 @@
         m_phy = nullptr;
     }
     m_propDelay.clear();
-    std::map<Mac8Address, AckData>::iterator it = m_ackData.begin();
+    auto it = m_ackData.begin();
     for (; it != m_ackData.end(); it++)
     {
         it->second.rxFrames.clear();
@@ -262,7 +262,7 @@
                 NS_LOG_DEBUG(Now().As(Time::S) << " GW storing reservation from " << ch.GetSrc()
                                                << " with length " << req.length);
                 m_requests.insert(std::make_pair(ch.GetSrc(), req));
-                std::map<Mac8Address, Time>::iterator it = m_propDelay.find(ch.GetSrc());
+                auto it = m_propDelay.find(ch.GetSrc());
                 if (it == m_propDelay.end())
                 {
                     m_sortedRes.insert(std::make_pair(m_maxDelta, ch.GetSrc()));
@@ -292,7 +292,7 @@
 void
 UanMacRcGw::StartCycle()
 {
-    uint32_t numRts = static_cast<uint32_t>(m_sortedRes.size());
+    auto numRts = static_cast<uint32_t>(m_sortedRes.size());
 
     if (numRts)
     {
@@ -309,7 +309,7 @@
     Time pDelay = Seconds(0);
     if (numRts > 0)
     {
-        std::map<Mac8Address, Request>::iterator rit = m_requests.begin();
+        auto rit = m_requests.begin();
         for (; rit != m_requests.end(); rit++)
         {
             totalBytes += (*rit).second.length;
@@ -408,7 +408,7 @@
     m_state = CTSING;
     Simulator::Schedule(nextEarliest, &UanMacRcGw::CycleStarted, this);
 
-    std::set<std::pair<Time, Mac8Address>>::iterator it = m_sortedRes.begin();
+    auto it = m_sortedRes.begin();
     Time minPdelay = (*it).first;
     Ptr<Packet> cts = Create<Packet>();
 
@@ -487,7 +487,7 @@
 
     Time ackTime = Seconds(m_ackSize * 8.0 / m_phy->GetMode(m_currentRateNum).GetDataRateBps());
 
-    std::map<Mac8Address, AckData>::iterator it = m_ackData.begin();
+    auto it = m_ackData.begin();
     for (; it != m_ackData.end(); it++)
     {
         Mac8Address dest = (*it).first;
@@ -507,7 +507,7 @@
         ch.SetType(UanMacRc::TYPE_ACK);
         UanHeaderRcAck ah;
         ah.SetFrameNo(data.frameNo);
-        std::list<uint32_t>::iterator nit = toNack.begin();
+        auto nit = toNack.begin();
         for (; nit != toNack.end(); nit++)
         {
             ah.AddNackedFrame(static_cast<uint8_t>(*nit));
@@ -598,7 +598,7 @@
 {
     uint32_t n = m_numNodes;
     std::vector<double> pds;
-    std::map<Mac8Address, Time>::iterator pdit = m_propDelay.begin();
+    auto pdit = m_propDelay.begin();
 
     for (; pdit != m_propDelay.end(); pdit++)
     {
@@ -664,7 +664,7 @@
     double sum = 0;
     for (uint32_t i = 1; i <= n - k + 1; i++)
     {
-        double nChK = static_cast<double>(NchooseK(n, k));
+        auto nChK = static_cast<double>(NchooseK(n, k));
         double p = (nChK > 0) ? (static_cast<double>(NchooseK(n - i, k - 1)) / nChK) : DBL_MAX;
         sum += p * i;
     }
@@ -674,7 +674,7 @@
 double
 UanMacRcGw::ComputePiK(uint32_t a, uint32_t n, uint32_t k)
 {
-    double nck = (double)NchooseK(n, k);
+    auto nck = (double)NchooseK(n, k);
     return nck * std::pow((std::exp((double)a / (double)n) - 1.0), (double)k) *
            std::exp(-((double)a));
 }
@@ -724,7 +724,7 @@
 {
     double tput = 0;
     uint32_t a = 1;
-    while (1)
+    while (true)
     {
         double newtput = ComputeExpS(a, m_frameSize);
         if (newtput < tput)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/uan/model/uan-noise-model-default.cc ns-3.40/src/uan/model/uan-noise-model-default.cc
--- ns-3.39/src/uan/model/uan-noise-model-default.cc	2023-07-05 14:23:48.097428300 -0700
+++ ns-3.40/src/uan/model/uan-noise-model-default.cc	2023-09-27 13:30:37.890839800 -0700
@@ -57,7 +57,7 @@
 }
 
 // Common acoustic noise formulas.  These can be found
-// in "Priniciples of Underwater Sound" by Robert J. Urick
+// in "Principles of Underwater Sound" by Robert J. Urick
 double
 UanNoiseModelDefault::GetNoiseDbHz(double fKhz) const
 {
@@ -71,18 +71,18 @@
     double thermalDb;
     double noiseDb;
 
-    turbDb = 17.0 - 30.0 * std::log10(fKhz);
+    double log_fKhz = std::log10(fKhz);
+
+    turbDb = 17.0 - 30.0 * log_fKhz;
     turb = std::pow(10.0, turbDb * 0.1);
 
-    shipDb =
-        40.0 + 20.0 * (m_shipping - 0.5) + 26.0 * std::log10(fKhz) - 60.0 * std::log10(fKhz + 0.03);
+    shipDb = 40.0 + 20.0 * (m_shipping - 0.5) + 26.0 * log_fKhz - 60.0 * std::log10(fKhz + 0.03);
     ship = std::pow(10.0, (shipDb * 0.1));
 
-    windDb = 50.0 + 7.5 * std::pow(m_wind, 0.5) + 20.0 * std::log10(fKhz) -
-             40.0 * std::log10(fKhz + 0.4);
+    windDb = 50.0 + 7.5 * std::pow(m_wind, 0.5) + 20.0 * log_fKhz - 40.0 * std::log10(fKhz + 0.4);
     wind = std::pow(10.0, windDb * 0.1);
 
-    thermalDb = -15 + 20 * std::log10(fKhz);
+    thermalDb = -15 + 20 * log_fKhz;
     thermal = std::pow(10, thermalDb * 0.1);
 
     noiseDb = 10 * std::log10(turb + ship + wind + thermal);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/uan/model/uan-noise-model-default.h ns-3.40/src/uan/model/uan-noise-model-default.h
--- ns-3.39/src/uan/model/uan-noise-model-default.h	2023-07-05 14:23:48.097428300 -0700
+++ ns-3.40/src/uan/model/uan-noise-model-default.h	2023-09-27 13:30:37.890839800 -0700
@@ -20,9 +20,10 @@
 #ifndef UAN_NOISE_MODEL_DEFAULT_H
 #define UAN_NOISE_MODEL_DEFAULT_H
 
+#include "uan-noise-model.h"
+
 #include "ns3/attribute.h"
 #include "ns3/object.h"
-#include "ns3/uan-noise-model.h"
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/uan/model/uan-phy-dual.cc ns-3.40/src/uan/model/uan-phy-dual.cc
--- ns-3.39/src/uan/model/uan-phy-dual.cc	2023-07-05 14:23:48.097428300 -0700
+++ ns-3.40/src/uan/model/uan-phy-dual.cc	2023-09-27 13:30:37.890839800 -0700
@@ -79,7 +79,7 @@
     }
 
     double intKp = -DbToKp(rxPowerDb); // This packet is in the arrivalList
-    UanTransducer::ArrivalList::const_iterator it = arrivalList.begin();
+    auto it = arrivalList.begin();
     for (; it != arrivalList.end(); it++)
     {
         // Only count interference if there is overlap in incoming frequency
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/uan/model/uan-phy-dual.h ns-3.40/src/uan/model/uan-phy-dual.h
--- ns-3.39/src/uan/model/uan-phy-dual.h	2023-07-05 14:23:48.097428300 -0700
+++ ns-3.40/src/uan/model/uan-phy-dual.h	2023-09-27 13:30:37.890839800 -0700
@@ -21,7 +21,7 @@
 #ifndef UAN_PHY_DUAL_H
 #define UAN_PHY_DUAL_H
 
-#include "ns3/uan-phy.h"
+#include "uan-phy.h"
 
 namespace ns3
 {
